VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "CheckIco"
   ClientHeight    =   1245
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2130
   LinkTopic       =   "Form1"
   ScaleHeight     =   1245
   ScaleWidth      =   2130
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdVerify 
      Caption         =   "Verify"
      Height          =   495
      Left            =   480
      TabIndex        =   0
      Top             =   360
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type Point
    Name As String
    X As Single
    Y As Single
    Z As Single
End Type

Private Type Edge
    Pt1 As Integer
    Pt2 As Integer
End Type

Private m_Points() As Point
Private m_Edges() As Edge
Private Function FindPointByName(ByVal point_name As String) As Integer
Dim i As Integer

    For i = 1 To UBound(m_Points)
        If m_Points(i).Name = point_name Then
            FindPointByName = i
            Exit For
        End If
    Next i
End Function

Private Sub cmdVerify_Click()
Const Pi = 3.14159265
Const S = 1#

Dim t1 As Single
Dim t2 As Single
Dim t3 As Single
Dim t4 As Single
Dim R As Single
Dim H As Single
Dim Cx As Single
Dim Cy As Single
Dim H1 As Single
Dim H2 As Single
Dim Z1 As Single
Dim Z2 As Single

Dim is_ok As Boolean
Dim i As Integer
Dim dist As Single
Dim dx As Single
Dim dy As Single
Dim dz As Single

    ' Calculate intermediate values.
    t1 = 2 * Pi / 5
    t2 = Pi / 10
    t4 = Pi / 5
    t3 = -3 * Pi / 10
    R = (S / 2) / Sin(t4)
    H = Cos(t4) * R
    Cx = R * Cos(t2)
    Cy = R * Sin(t2)
    Z2 = 1
    H1 = Sqr(S * S - R * R)
    H2 = Sqr((H + R) * (H + R) - H * H)
    Z2 = (H2 - H1) / 2
    Z1 = Z2 + H1

    ' Create the points.
    MakePoint "a", 0, 0, Z1
    MakePoint "b", 0, R, Z2
    MakePoint "c", Cx, Cy, Z2
    MakePoint "d", S / 2, -H, Z2
    MakePoint "e", -S / 2, -H, Z2
    MakePoint "f", -Cx, Cy, Z2
    MakePoint "g", 0, -R, -Z2
    MakePoint "h", -Cx, -Cy, -Z2
    MakePoint "i", -S / 2, H, -Z2
    MakePoint "j", S / 2, H, -Z2
    MakePoint "k", Cx, -Cy, -Z2
    MakePoint "l", 0, 0, -Z1

    ' Make the edges.
    MakeEdge "a", "b"
    MakeEdge "a", "c"
    MakeEdge "a", "d"
    MakeEdge "a", "e"
    MakeEdge "a", "f"

    MakeEdge "b", "c"
    MakeEdge "c", "d"
    MakeEdge "d", "e"
    MakeEdge "e", "f"
    MakeEdge "f", "b"

    MakeEdge "b", "j"
    MakeEdge "j", "c"
    MakeEdge "c", "k"
    MakeEdge "k", "d"
    MakeEdge "d", "g"
    MakeEdge "g", "e"
    MakeEdge "e", "h"
    MakeEdge "h", "f"
    MakeEdge "f", "i"
    MakeEdge "i", "b"

    MakeEdge "g", "h"
    MakeEdge "h", "i"
    MakeEdge "i", "j"
    MakeEdge "j", "k"
    MakeEdge "k", "g"

    MakeEdge "l", "g"
    MakeEdge "l", "h"
    MakeEdge "l", "i"
    MakeEdge "l", "j"
    MakeEdge "l", "k"

    ' Verify that all edges are S units long.
    is_ok = True
    For i = 1 To UBound(m_Edges)
        With m_Edges(i)
            dx = m_Points(.Pt1).X - m_Points(.Pt2).X
            dy = m_Points(.Pt1).Y - m_Points(.Pt2).Y
            dz = m_Points(.Pt1).Z - m_Points(.Pt2).Z
            dist = Sqr(dx * dx + dy * dy + dz * dz)
            If Abs(S - dist) > 0.00001 Then
                is_ok = False
                Exit For
            End If
        End With
    Next i

    If is_ok Then
        MsgBox "The edges are all S units long!"
    Else
        MsgBox "Oops. The edges are not all S units long."
    End If
End Sub
' Add an edge to the m_Edges array.
Private Sub MakeEdge(ByVal name1 As String, ByVal name2 As String)
Dim num_edges As Integer

    ' Make room.
    On Error Resume Next
    num_edges = UBound(m_Edges)
    On Error GoTo 0
    num_edges = num_edges + 1
    ReDim Preserve m_Edges(1 To num_edges)

    ' Make the edge
    With m_Edges(num_edges)
        .Pt1 = FindPointByName(name1)
        .Pt2 = FindPointByName(name2)
    End With
End Sub

' Add a point to the m_Points array.
Private Sub MakePoint(ByVal new_name As String, ByVal X As Single, ByVal Y As Single, ByVal Z As Single)
Dim num_points As Integer

    ' Make room.
    On Error Resume Next
    num_points = UBound(m_Points)
    On Error GoTo 0
    num_points = num_points + 1
    ReDim Preserve m_Points(1 To num_points)

    ' Create the point.
    With m_Points(num_points)
        .Name = new_name
        .X = X
        .Y = Y
        .Z = Z
    End With
End Sub

